/*****************************************************

	: ,     
	
******************************************************

	 2011 ??????.
	   .  , 
	     .

******************************************************

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	 ,   :  ,   
	-      ,  
	 .

*****************************************************/

#include "lcd.h"

void lcd_send(char data)
{
	char tmp;
	DDR_LCD = 0xff;
	tmp  = PORT_LCD & 0x0f;
	tmp |= (data & 0xf0);

	PORT_LCD = tmp;		//    
	PORT_LCD.LCD_EN = 1;
	delay_send();
	PORT_LCD.LCD_EN = 0;

	tmp  = PORT_LCD & 0x0f;
	tmp |= (data << 4);


	PORT_LCD = tmp;		//    
	PORT_LCD.LCD_EN = 1;
	delay_send();
	PORT_LCD.LCD_EN = 0;
	DDR_LCD = 0b00001101;
}

void lcd_cmd(unsigned char data)
{
	delay_exec();
	PORT_LCD.LCD_RS = 0;
	lcd_send(data);
}

void lcd_init()
{
	DDR_LCD = 0xff;
	PORT_LCD = 0x00;
	delay_start();
  
	PORT_LCD = 0x20;
	PORT_LCD.LCD_EN = 1;
	delay_send();
	PORT_LCD.LCD_EN = 0;

	lcd_cmd(0b00101000);	//   , 2 
	lcd_cmd(0b00001100);	//  ,    
	lcd_cmd(0b00000001);	//  
	lcd_cmd(0b00000110);	//    
}

void lcd_reset()
{
	LCD_RESET = 1;
	delay_reset();
	LCD_RESET = 0;
}

void print_char(unsigned char data)
{
	if (data == 0x30) data = 0x4f;	//      (   )
	delay_exec();
	PORT_LCD.LCD_RS = 1;
	lcd_send(data);
}

void print(char *str)
{
	unsigned char data;
	while (*str)
	{
		data = *str++;
		print_char(data);
	}
}

void print_flash(char __flash *str)
{
	unsigned char data;			
	while (*str)
	{
		data = *str++;
		print_char(data);
	}
}

void print_eeprom(char __eeprom *str)
{
	unsigned char data;			
	while (*str)
	{
		data = *str++;
		print_char(data);
	}
}

void print_number(unsigned int number, char comma)
{
	/*****************************************************
	   ,     
	 ,    printf.    
	 ,        .
	        . ,
	       ,   
	   ,       .
	*****************************************************/
	char i;

	lcd_cmd(0b00000100);	//    
	
	for (i = 0; i < 6; i++)
	{
		if (i == comma)
		{
			print_char(0x2E);	//  , .    ...
		}
		else if (number == 0)
		{
			if (i <= comma+1) print_char(0x30);	// 
		}
		else
		{
			/*    10,        */
			print_char((number % 10)+0x30);
			number /= 10;
		}
	}
	lcd_cmd(0b00000110);	//    
}

void lcd_clear()
{
	lcd_cmd(0x01);
	delay_clear();
}
