/*****************************************************

	: ,     
	
******************************************************

	 2011 ??????.
	   .  , 
	     .

******************************************************

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	 ,   :  ,   
	-      ,  
	 .

******************************************************
	  
*****************************************************/

#include <tiny2313a.h>	//   CodeVisionAVR    :(
#include <delay.h>

#define PORT_LCD PORTB
#define DDR_LCD DDRB

#define LCD_RS 1	// Register select
#define LCD_BL 0	// Backlight
#define LCD_EN 3	// Write enable signal

#define LCD_RESET PORTD.6	//  

// 
//      ,         ,    ,      
#define delay_send() delay_us(10)	//    
#define delay_exec() delay_us(50)	//    (  )
#define delay_clear() delay_ms(2)	//   
#define delay_start()  delay_ms(100)	//      
#define delay_reset()	delay_ms(50)	//    

//  
#define LCD_LINE1 0b10000000
#define LCD_LINE2 0b11000000

/******************************************************
	  
*****************************************************/

void lcd_init();
void lcd_reset();
void lcd_clear();
void lcd_cmd(unsigned char data);
void print_char(unsigned char data);
void print(char *str);
void print_flash(char __flash *str);
void print_eeprom(char __eeprom *str);
void print_number(unsigned int number, char comma);
