/*****************************************************

	:     RC-
	   

	:		ATtiny2313
	  :	500,00 kHz
	:		CodeVisionAVR 2.04
	
******************************************************

	 2011 ??????.
	   .  , 
	     .

******************************************************

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	 ,   :  ,   
	-      ,  
	 .

******************************************************
	
*****************************************************/

#define BUTTON1 PIND.0	//  1 -  
#define BUTTON2 PIND.3	//  2 - /      
#define BUTTON3 PIND.1	//  3 - /      

#define PRESS_TIMEOUT 2000	//   .      ,    

/*****************************************************
	  
*****************************************************/

#include <tiny2313a.h>	//   tiny2313a.h,       21 (Project -> Configure -> C Compiler -> Advanced)
#include <delay.h>
#include "lcd.h"

#define set_bit(p, n)		p |= (1 << (n))
#define clear_bit(p, n)		p &= ~(1 << (n))
#define invert_bit(p, n)	p ^= (1 << (n))
#define get_bit(a, b)		(a & 1<<b)

/*****************************************************
	
*****************************************************/

bit pressed,char_test;

register unsigned int wait;
char cur_char;

flash char osccal_str[] = {"OSCCAL  "};
flash char char_str[] = {"Char:"};

/*****************************************************
	 
*****************************************************/
void button_pressed();
void display_main();
/*****************************************************
	 
*****************************************************/

void main(void)
{
	PORTD = 0b0001111;
	DDRD =  0b1110000;

	TCCR0A=	0b00100011;
	TCCR0B=	0b00001001;
	OCR0A = 9;
	OCR0B = 4;

	TCCR1A=	0b00000000;
	TCCR1B=	0b00000000;

	TIMSK =	0b01000000;

	USICR =	0x00;

	ACSR =	0x80;

	wait = PRESS_TIMEOUT;
	lcd_init();
	PORTB.0 = 1;
	PORTB.2 = 1;
	display_main();
	
	while (1)
	{
		if (wait < PRESS_TIMEOUT)
		{
			wait++;
		}
		else
		{
			if (pressed == 1)
			{
				if (BUTTON1 == 1 && BUTTON2 == 1 && BUTTON3 == 1)		//  !    .    
				{
					pressed = 0;
					wait = 0;
				}
			}
			else		// ,      .    - 
			{
				/*    */
				if (BUTTON1 == 0)
				{
					char_test = !char_test;
					button_pressed();
				}
				else if (BUTTON2 == 0)
				{
					if (char_test == 0)
					{
						if (OSCCAL != 0)
						{
							OSCCAL--;
						}
					}
					else
					{
						cur_char--;
					}
					button_pressed();
				}
				else if (BUTTON3 == 0)
				{
					if (char_test == 0)
					{
						if (OSCCAL < 127)
						{
							OSCCAL++;
						}
					}
					else
					{
						cur_char++;
					}
					button_pressed();
				}
			}
		}
	};
}

void button_pressed()
{
	wait = 0;
	pressed = 1;
	display_main();
}

/*****************************************************
	   
*****************************************************/

void display_main()
{
	lcd_clear();
	lcd_cmd(LCD_LINE1);
	if (char_test == 0)
	{
		print_flash(osccal_str);
		lcd_cmd(LCD_LINE2+7);
		print_number(OSCCAL,0xff);
	}
	else
	{
		char i;
		print_flash(char_str);
		lcd_cmd(LCD_LINE1+7);
		print_number(cur_char,0xff);
		lcd_cmd(LCD_LINE2);
		for (i = 0; i < 8; i++)
		{
			print_char(cur_char);
		}
	}
}
