--[[##################################################################################

	       CP1251  ,
	   KS0066

###################################################################################

	 2011 ??????

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	 ,   :  ,   
	-      ,  
	 .

###################################################################################]]
--	

local sInFile = "in.txt"	--  
local sOutFile = "out.txt"	--  

--###################################################################################
tCharset = {
	[""] = 200, [""] = 201, [""] = 204, [""] = 253, [""] = 254, [""] = 65, [""] = 160, [""] = 66, [""] = 161,
	[""] = 224, [""] = 69, [""] = 162, [""] = 163, [""] = 164, [""] = 165, [""] = 166, [""] = 75, [""] = 167,
	[""] = 77, [""] = 72, [""] = 79, [""] = 168, [""] = 80, [""] = 67, [""] = 84, [""] = 169, [""] = 170,
	[""] = 88, [""] = 225, [""] = 171, [""] = 172, [""] = 226, [""] = 173, [""] = 174, [""] = 98, [""] = 175,
	[""] = 176, [""] = 177, [""] = 97, [""] = 178, [""] = 179, [""] = 180, [""] = 227, [""] = 101, [""] = 181,
	[""] = 182, [""] = 183, [""] = 184, [""] = 185, [""] = 186, [""] = 187, [""] = 188, [""] = 189, [""] = 111,
	[""] = 190, [""] = 112, [""] = 99, [""] = 191, [""] = 121, [""] = 228, [""] = 120, [""] = 229, [""] = 192,
	[""] = 193, [""] = 230, [""] = 194, [""] = 195, [""] = 196, [""] = 197, [""] = 198, [""] = 199,
}

function ToHex(byte)
	local tHex = {[10] = "A", [11] = "B", [12] = "C", [13] = "D", [14] = "E", [15] = "F"}
	local b1,b2 = math.floor(byte/16),math.fmod(byte,16)
	return (tHex[b1] or b1)..(tHex[b2] or b2)
end

local f = io.open(sInFile)
local f2 = io.open(sOutFile,"w")
for line in f:lines() do
	f2:write("{")
	for i = 1, #line do
		local char = line:sub(i,i)
		if tCharset[char] then
			f2:write("0x",ToHex(tCharset[char]),", ")
		else
			f2:write("0x",ToHex(char:byte()),", ")
		end
	end

	f2:write("0x00}\t// ",line,"\n")
end
f:close()
f2:close()