--[[##################################################################################

	   ,   
	 .

###################################################################################

	 2011 ??????

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	 ,   :  ,   
	-      ,  
	 .

###################################################################################]]
--	

tCfg = {
	--  
	Folder = "images/",	--    
    TextFile = "display.txt",	-- ,   
	NamePrefix = "disp",	--   
	NumberLen = 2,	--    

	--  
	CharX = 5,	--     X
	CharY = 8,	--     Y
	Chars = 8,	--    
	Rows = 2,	--  
	
	--  
	PixelSize = 2,	--  
	PixelSpace = 0,	--   
	CharSpace = 3,	--   
	RowSpace = 3,	--   
	HorSpace = 15,	--        
	VertSpace = 7,	--        
	BorderX = 5,	--     
	BorderY = 15,	--     

	BGColor = {150,255,0},	--     {R(0-255), G(0-255), B(0-255)}
	PixelColor = {0,0,0},	--  
	PixelAlpha = 48,	--    (0-127)
	UnusedPixelAlpha = 124,	--   
	BorderColor = {32,0,0},	--  
}

--##################################################################################

str = "ABCD"
require("gd")

function Main()
    os.execute('md "'..tCfg.Folder..'"')
	local x = tCfg.BorderX*2+tCfg.HorSpace*2+tCfg.CharSpace*(tCfg.Chars-1)+(tCfg.PixelSize*tCfg.CharX+tCfg.PixelSpace*(tCfg.CharX-1))*tCfg.Chars
	local y = tCfg.BorderY*2+tCfg.VertSpace*2+tCfg.RowSpace*(tCfg.Rows-1)+(tCfg.PixelSize*tCfg.CharY+tCfg.PixelSpace*(tCfg.CharY-1))*tCfg.Rows
	local im,colors
	local cur_row,im_num = 0,1
	
	local f = io.open(tCfg.TextFile)
--[[
	local text = {}
	for str in f:lines() do
		table.insert(text,str)
	end
]]	
	for str in f:lines() do
		cur_row = cur_row+1
		if not im or cur_row > tCfg.Rows then
			cur_row = 1
			if im then
				im:png(tCfg.Folder..tCfg.NamePrefix..(#tostring(im_num) < tCfg.NumberLen and ("0"):rep(tCfg.NumberLen-#tostring(im_num)) or "")..im_num..".png")
				im_num = im_num+1
			end
			im = gd.createTrueColor(x,y)
			colors = {
				border = im:colorAllocate(tCfg.BorderColor[1],tCfg.BorderColor[2],tCfg.BorderColor[3]),
				bg = im:colorAllocate(tCfg.BGColor[1],tCfg.BGColor[2],tCfg.BGColor[3]),
				pix = im:colorAllocateAlpha(tCfg.PixelColor[1],tCfg.PixelColor[2],tCfg.PixelColor[3],tCfg.PixelAlpha),
				upix = im:colorAllocateAlpha(tCfg.PixelColor[1],tCfg.PixelColor[2],tCfg.PixelColor[3],tCfg.UnusedPixelAlpha),
			}
			im:filledRectangle(0,0,x,y,colors.border)
			im:filledRectangle(tCfg.BorderX,tCfg.BorderY,x-tCfg.BorderX-1,y-tCfg.BorderY-1,colors.bg)
		end
		local char_y = tCfg.VertSpace+tCfg.BorderY+(tCfg.PixelSize*tCfg.CharY+tCfg.PixelSpace*(tCfg.CharY-1)+tCfg.RowSpace)*(cur_row-1)
		for i = 1, tCfg.Chars do
			local char_x = tCfg.HorSpace+tCfg.BorderX+(tCfg.PixelSize*tCfg.CharX+tCfg.PixelSpace*(tCfg.CharX-1)+tCfg.CharSpace)*(i-1)
			local char = str:sub(i,i)
			if tCharRemap[char] then
				char = tCharRemap[char]
			elseif #char == 0 or not tChars[char] then
				char = " "
			end
			for j = 1,tCfg.CharY do
				local pix_y = char_y+(tCfg.PixelSize+tCfg.PixelSpace)*(j-1)
				if not tChars[char][j] then
					tChars[char][j] = {}
					for l = 1, tCfg.CharX do
						tChars[char][j][l] = 0
					end
				end
				if tChars[char][j] then
					for k = 1, tCfg.CharX do
						local pix_x = char_x+(tCfg.PixelSize+tCfg.PixelSpace)*(k-1)
						im:filledRectangle(pix_x,pix_y,pix_x+tCfg.PixelSize-1,pix_y+tCfg.PixelSize-1,(tChars[char][j][k] == 1 and colors.pix or colors.upix))
					end
				end
			end
		end
	end
	if im then
		im:png(tCfg.Folder..tCfg.NamePrefix..(#tostring(im_num) < tCfg.NumberLen and ("0"):rep(tCfg.NumberLen-#tostring(im_num)) or "")..im_num..".png")
	end
end

function LoadChars()
	tChars,tCharRemap = {},{}
	local char,char_y
	local f = io.open("chars.txt")
	for line in f:lines() do
		local c = line:match("/(.)%s-")
		if c then
			local remap = line:match("/.=(.)%s-")
			if remap then
				char = nil
				tCharRemap[c] = remap
			else
				char = c
				char_y = 1
				tChars[char] = {}
			end
		elseif char and char_y <= tCfg.CharY then
			tChars[char][char_y] = {}
			for i = 1,tCfg.CharX do
				c = line:sub(i,i)
				if #c == 0 or c:find("^%s$") then
					tChars[char][char_y][i] = 0
				else
					tChars[char][char_y][i] = 1
				end
			end
			char_y = char_y+1
		end
	end
	f:close()
	
	tChars[" "] = {}
	for i = 1,tCfg.CharY do
		tChars[" "][i] = {}
		for j = 1, tCfg.CharX do
			tChars[" "][i][j] = 0
		end
	end
end

LoadChars()
Main()