/*****************************************************

	 1.00

	:		ATtiny2313
	  :	500,00 kHz
	:		CodeVisionAVR 2.04
	
******************************************************

	 2011 ??????.
	   .  , 
	     .

******************************************************

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	 ,   :  ,   
	-      ,  
	 .

******************************************************
FUSE BITS

	!    ,     PonyProg  CodeVisionAVR: 0 -  ; 1 -  .
	     ,       -    ,     Atmel'.

	 :     : 1  "unprogrammed", 0 - "programmed". T.e 1  0,  0  1. (o_O)
	  Atmel',       ,      .
	
	       ,       .
	
	:
	
	SELFPRGEN	0

	DWEN 	0
	EESAVE 	0
	SPIEN 	1
	WDTON 	0
	BODLEVEL2 	0
	BODLEVEL1 	0
	BODLEVEL0 	0
	RSTDISBL 	0
	
	   500 kHz:
	CKDIV8 	0
	
	   4 MHz   RC-:
	CKDIV8 	1
	
	CKOUT 	0
	SUT1 	0
	SUT0 	1
	
	  RC-:
	CKSEL3 	1
	CKSEL2 	1
	CKSEL1 	0
	CKSEL0 	1

	  :
	CKSEL3 	0
	CKSEL2 	0
	CKSEL1 	1
	CKSEL0 	0

******************************************************
	
*****************************************************/

#define LANG_RUSSIAN	//   .         

//#define USER_OSCCAL 63	//   RC-.       

#define BUTTON1 PIND.0	//  1 -  
#define BUTTON2 PIND.3	//  2 - /      
#define BUTTON3 PIND.1	//  3 - /      
#define ENABLE_DCCONV PORTD.4
#define ENABLE_LIGHT PORTD.5

#define PRESS_TIMEOUT 1500	//   .      ,    

#define SPEED_MULTIPLIER 176	// ,    . (  TCNT1*0.36)
#define MAIN_TIMER 2441	//   (  TCNT1*5)

//#define SAVE_TO_EEPROM	//        

/*****************************************************
	  
*****************************************************/

#include <tiny2313a.h>	//   tiny2313a.h,       21 (Project -> Configure -> C Compiler -> Advanced)
#include <delay.h>
#include "lcd.h"

#define set_bit(p, n)		p |= (1 << (n))
#define clear_bit(p, n)		p &= ~(1 << (n))
#define invert_bit(p, n)	p ^= (1 << (n))
#define get_bit(a, b)		(a & 1<<b)

#define light_on() set_bit(TCCR0A,COM0B1)
#define tmr_reset() tmr_count = 0

/*****************************************************
	
*****************************************************/

bit pressed,conf_mode,go_to_bed,good_morning,light,update_info,stopped;

register unsigned int mileage_current @2;
register unsigned int mileage_current_low @4;
register unsigned int mileage_total_low @6;
#ifdef SAVE_TO_EEPROM
eeprom unsigned int mileage_total = 0;
#else
register unsigned int mileage_total @8;
#endif

register unsigned int wait;
register char tmr_count;
register unsigned int speed_count;
char conf_state;
char conf_count;

#define CONF_COUNT 12

#define CONF_SPEED 0
#define CONF_MILEAGE 1
#define CONF_LIGHT_AUTO 2
#define CONF_LIGHT_TIME 3
#define CONF_LIGHT_PWM 4
#define CONF_CONTRAST 5
#define CONF_AUTO_ON 6
#define CONF_AUTO_OFF 7
#define CONF_BACKLIGHT 8
#define CONF_RESET_CURRENT 9
#define CONF_RESET_TOTAL 10
#define CONF_WHEEL 11


char conf_temp[CONF_COUNT];

flash char conf_max[CONF_COUNT] =	{	1,	1,	1,	48,	7,	15,	1,	48,	1,	1,	1,	255};	//   

eeprom char conf[CONF_COUNT] = 		{	0,	0,	1,  0,	5,	7,	1,	6,	1,	0,	0,	221};	//   

#ifdef LANG_RUSSIAN
eeprom char conf_str[CONF_COUNT][9] = {
	{0x43, 0xBA, 0x6F, 0x70, 0x6F, 0x63, 0xBF, 0xC4, 0x00},	// 
	{0xA8, 0x70, 0x6F, 0xB2, 0x65, 0xB4, 0x20, 0x20, 0x00},	//   
	{0x41, 0xB3, 0xBF, 0x2E, 0xE4, 0x61, 0x70, 0x61, 0x00},	// .
	{0x42, 0xC3, 0xBA, 0x2E, 0xE4, 0x61, 0x70, 0xC3, 0x00},	// .
	{0xB1, 0x70, 0xBA, 0x2E, 0xE4, 0x61, 0x70, 0xC3, 0x00},	// .
	{0x4B, 0x6F, 0xBD, 0xBF, 0x70, 0x61, 0x63, 0xBF, 0x00},	// 
	{0x41, 0xB3, 0xBF, 0x6F, 0xB3, 0xBA, 0xBB, 0x2E, 0x00},	// .
	{0x41, 0xB3, 0xBF, 0x6F, 0x6F, 0xBF, 0xBA, 0xBB, 0x00},	// 
	{0xA8, 0x6F, 0xE3, 0x63, 0xB3, 0x65, 0xBF, 0xBA, 0x00},	// 
	{0x43, 0xB2, 0x70, 0x2E, 0x20, 0xBF, 0x65, 0xBA, 0x00},	// . 
	{0x43, 0xB2, 0x70, 0x2E, 0x20, 0x6F, 0xB2, 0xE6, 0x00},	// . 
	{0x4B, 0x6F, 0xBB, 0x65, 0x63, 0x6F, 0x20, 0x20, 0x00},	//   
};

flash char yesno_str[2][4] = {
	{0xBD, 0x65, 0xBF, 0x00},	// 
	{0xE3, 0x61, 0x20, 0x00}	//  
};

flash char cm_str[] = {0x63, 0xBC, 0x00};
flash char km_str[] = {0xBA, 0xBC, 0x00};
flash char kmph_str[] = {0xBA, 0xBC, 0x2F, 0xC0, 0x00};	// /
eeprom char sec_str[] = {0x63, 0x65, 0xBA, 0x00};	// 
flash char never_str[] = {0xBD, 0xB8, 0xBA, 0x6F, 0xB4, 0xE3, 0x61, 0x20, 0x00};	// 

flash char speed_str[2][7] = {
	{0xBD, 0x6F, 0x70, 0xBC, 0x20, 0x20, 0x00},	//     
	{0x70, 0x65, 0xBA, 0x6F, 0x70, 0xE3, 0x00}	//   
};

flash char mileage_str[3][8] = {
	{0xBF, 0x65, 0xBA, 0x79, 0xE6, 0xB8, 0xA6, 0x00},	// 
	{0x6F, 0xB2, 0xE6, 0xB8, 0xA6, 0x20, 0x20, 0x00},	// 
};
#else
eeprom char conf_str[CONF_COUNT][9] = {
	"Speed   ",
	"Mileage ",
	"LightAut",
	"LightOff",
	"LightBri",
	"Contrast",
	"Auto on ",
	"Auto off",
	"B. light",
	"Rst cur ",
	"Rst tot ",
	"Wheel   "
};

flash char yesno_str[2][4] = {
	{"no "},
	{"yes"}
};

flash char cm_str[] = {"cm"};
flash char km_str[] = {"km"};
flash char kmph_str[] = {"kmph"};
eeprom char sec_str[] = {"sec"};
flash char never_str[] = {"never   "};

flash char speed_str[2][7] = {
	{"normal"}, 
	{"top   "}
};

flash char mileage_str[3][8] = {
	{"current"},
	{"total  "},
};
#endif

/*****************************************************
	 
*****************************************************/

void button_pressed();
void wake_up();
void light_off();
void light_reset();
void exit_conf_mode();
void display_main();
void display_conf();
void load_conf();
void save_conf();
void apply_conf();

/*****************************************************
	 
*****************************************************/

void main(void)
{
#ifdef USER_OSCCAL
	OSCCAL = USER_OSCCAL;
#endif

	PORTD = 0b0011111;
	DDRD =  0b1110000;

	TCCR0A=	0b10000011;
	TCCR0B=	0b00000001;

	TCCR1A=	0b00000000;
	TCCR1B=	0b00001101;
	OCR1A =	MAIN_TIMER; // ~5 

	wake_up();

	TIMSK =	0b01000000;

	USICR =	0x00;

	ACSR =	0x80;

	wait = PRESS_TIMEOUT;

	//          ...
#ifdef SAVE_TO_EEPROM
	load_conf();
#asm
	ldi R30, 0x0f
	cp R30, R17
	breq skip_reset_conf
#endasm
	mileage_current = 0;
	mileage_current_low = 0;
	mileage_total_low = 0;	
#else
	if (BUTTON1 == 1 || BUTTON3 == 1)
	{
#asm
	ldi R30, 0x0f
	cp R30, R17
	breq skip_reset_conf
#endasm
	}
	load_conf();
	mileage_current = 0;
	mileage_current_low = 0;
	mileage_total = 0;
	mileage_total_low = 0;
#endif
#asm
skip_reset_conf:
	ldi R17, 0x0f
#endasm
	//         end.

	good_morning = 1;
	#asm("sei");
	
	while (1)
	{
		if (wait < PRESS_TIMEOUT)
		{
			wait++;
		}
		else
		{
			if (pressed == 1)
			{
				if (BUTTON1 == 1 && BUTTON2 == 1 && BUTTON3 == 1)		//  !    .    
				{
					pressed = 0;
					wait = 0;
				}
			}
			else		// ,      .    - 
			{
				if (conf_mode == 0 && update_info != 0)
				{
					update_info = 0;
					display_main();
				}
				if (go_to_bed != 0)
				{
					#asm("cli")
					exit_conf_mode();	//   
					speed_count = 0;

					//  
					clear_bit(TCCR0A,COM0A1);
					PORT_LCD = 0;
					
					light_off();
					ENABLE_DCCONV = 1;	// 0 - , 1 - .      :)
					if (conf_temp[CONF_AUTO_ON] == 0)
					{
#ifdef _TINY2313A_INCLUDED_
						GIMSK = 0b10010000;
#else
						GIMSK = 0b10000000;
#endif
					}
					else
					{
#ifdef _TINY2313A_INCLUDED_
						GIMSK = 0b11010000;
#else
						GIMSK = 0b11000000;
#endif
					}
#ifdef _TINY2313A_INCLUDED_
					PCMSK2 = 0b00000010;
#endif
					go_to_bed = 0;
					good_morning = 1;
					MCUCR = 0b01110000;
#asm
					sei
					sleep
#endasm
				}
				if (good_morning != 0)
				{
					good_morning = 0;

					//     
					lcd_reset();
					ENABLE_DCCONV = 0;	// 0 - , 1 - .      :)
					lcd_init();
					set_bit(TCCR0A,COM0A1);
					
					light_reset();
					
					apply_conf();
					update_info = 1;
					conf_count = CONF_COUNT-((BUTTON1 == 0) ? 0 : 2);	//     1 ,   
					button_pressed();
				}
				
				/*    */
				else if (BUTTON1 == 0)
				{
					if (conf_mode == 0)
					{
						conf_mode = 1;
						conf_state = 0;
					}
					else
					{
						conf_state++;
					}
					if (conf_state >= conf_count)
					{
						exit_conf_mode();
					}
					else
					{
						WDTCSR = 0b01100000;	//      4 
						display_conf();
					}
					button_pressed();
				}
				else if (BUTTON2 == 0)
				{
					if (conf_mode == 0)
					{
						go_to_bed = 1;
					}
					else
					{
						if (conf_temp[conf_state] != 0)
						{
							conf_temp[conf_state]--;
						}
						apply_conf();
						display_conf();
					}
					button_pressed();
				}
				else if (BUTTON3 == 0)
				{
					if (conf_mode == 0)
					{
						
						if (light == 0)
						{
							light = 1;
							light_on();
						}
						else
						{
							if (get_bit(TCCR0A,COM0B1) == 0)
							{
								light_on();
							}
							else
							{
								light = 0;
								light_off();
							}
						}
					}
					else
					{
						if (conf_temp[conf_state] < conf_max[conf_state])
						{
							conf_temp[conf_state]++;
						}
						apply_conf();
						display_conf();
					}
					button_pressed();
				}
			}
		}
	};
}

void button_pressed()
{
	wait = 0;
	pressed = 1;
	#asm("wdr");
	tmr_reset();
}
/*****************************************************
	
*****************************************************/

interrupt [EXT_INT0] void int0(void)
{
	wake_up();
	/*      */
	if (stopped != 0)
	{
		stopped = 0;
		speed_count = 0;
	}
	else if (conf_temp[CONF_SPEED] == 0 || (TCNT1 < speed_count || speed_count == 0))
	{
		speed_count = TCNT1;
	}
	TCNT1 = 0;
	
	light_reset();
	tmr_reset();
	
	/*      */
	mileage_current_low = mileage_current_low+conf_temp[CONF_WHEEL];
	if (mileage_current_low >= 1000)
	{
		mileage_current++;
		mileage_current_low -= 1000;
		mileage_total_low++;
		if (mileage_total_low >= 100)
		{
			mileage_total++;
			mileage_total_low = 0;
		}
	}
	update_info = 1;
}

interrupt [EXT_INT1] void int1(void)
{
	wake_up();
}

interrupt [TIM1_COMPA] void timer_overflow(void)
{
	if (stopped == 0)
	{
		stopped = 1;
		speed_count = 0;
		update_info = 1;
	}
	if (tmr_count < 240 && conf_mode == 0)
	{
		tmr_count++;
		if (conf_temp[CONF_LIGHT_TIME] == tmr_count)
		{
			light_off();
		}
		if (conf_temp[CONF_AUTO_OFF] == tmr_count)
		{
			go_to_bed = 1;
		}
	}
}

#ifdef _TINY2313A_INCLUDED_
interrupt [21] void light_int(void)	// PCINT1
{
	wake_up();
	light = 1;
}
#endif

/*****************************************************
	 
*****************************************************/
void light_off()
{
	if (conf_temp[CONF_LIGHT_AUTO] == 0) light = 0;
	clear_bit(TCCR0A,COM0B1);
	ENABLE_LIGHT = 0;
}

void light_reset()
{
	if (light == 1)
	{
		light_on();
	}
}

void wake_up()
{
	MCUCR = 0b01011010;	//   : Power-Down; INT0  INT1   
#ifdef _TINY2313A_INCLUDED_
	GIMSK = 0b01010000;
	PCMSK2 = 0;
#else
	GIMSK = 0b01000000;
#endif
	
}

/*****************************************************
	   
*****************************************************/

void display_main()
{
//	lcd_clear();
	//      ,       
	char i;
	lcd_cmd(LCD_LINE1);
	print_char(0x20);
	lcd_cmd(LCD_LINE2);
	for (i = 0; i < 5; i++)
	{
		print_char(0x20);
	}
	
	lcd_cmd(LCD_LINE1+4);
	print_flash(kmph_str);
	
	lcd_cmd(LCD_LINE1+3);
	if (speed_count == 0)
	{
		print_number(0,1);
	}
	else
	{
		//    begin
		int speed = ((unsigned int)conf_temp[CONF_WHEEL]*SPEED_MULTIPLIER)/speed_count;
		//    end
		if (speed > 999)
		{
			speed = 999;
		}
		print_number(speed,1);
	}
	
	lcd_cmd(LCD_LINE2+5);
	if (conf_temp[CONF_MILEAGE] == 0)
	{
		print_number(mileage_current,2);
	}
	else
	{
		print_number(mileage_total,0xff);
	}
	lcd_cmd(LCD_LINE2+6);
	print_flash(km_str);
}

void display_conf()
{
	char data = conf_temp[conf_state];
	lcd_clear();
	print_eeprom(conf_str[conf_state]);
	lcd_cmd(LCD_LINE2);
	if (conf_state == CONF_LIGHT_AUTO || conf_state == CONF_AUTO_ON || conf_state == CONF_BACKLIGHT || conf_state == CONF_RESET_CURRENT || conf_state == CONF_RESET_TOTAL)	// /
	{
		print_flash(yesno_str[data]);
	}
	else if (conf_state == CONF_SPEED)	// 
	{
		print_flash(speed_str[data]);
	}
	else if (conf_state == CONF_MILEAGE)	// 
	{
		print_flash(mileage_str[data]);
	}
	else if (conf_state == CONF_LIGHT_TIME || conf_state == CONF_AUTO_OFF)	//  
	{
		if (data == 0)
		{
			print_flash(never_str);
		}
		else
		{
			lcd_cmd(LCD_LINE2+2);
			print_number(data*5,0xff);
			lcd_cmd(LCD_LINE2+4);
			print_eeprom(sec_str);
		}
	}
	else
	{
		if (conf_state == CONF_WHEEL)
		{
			lcd_cmd(LCD_LINE2+4);
			print_flash(cm_str);
		}
		lcd_cmd(LCD_LINE2+2);
		print_number(data,0xff);
	}
}

/*****************************************************
	 
*****************************************************/

void load_conf()
{
	char i;
	
	for (i = 0; i < CONF_COUNT; i++)
	{
		conf_temp[i] = conf[i];
	}
}

void apply_conf()
{
	PORT_LCD.LCD_BL = conf_temp[CONF_BACKLIGHT];
	OCR0A = conf_temp[CONF_CONTRAST]*conf_temp[CONF_CONTRAST]+30;
	OCR0B = 0xff >> (7-conf_temp[CONF_LIGHT_PWM]);
}


void save_conf()
{
#ifdef SAVE_TO_EEPROM
	char i;
#endif
	
	if (conf_temp[CONF_RESET_CURRENT] == 1)
	{
		mileage_current = 0;
		mileage_current_low = 0;
		conf_temp[CONF_RESET_CURRENT] = 0;
	}
	if (conf_temp[CONF_RESET_TOTAL] == 1)
	{
		mileage_total = 0;
		mileage_total_low = 0;
		conf_temp[CONF_RESET_TOTAL] = 0;
	}
#ifdef SAVE_TO_EEPROM
	for (i = 0; i < CONF_COUNT; i++)
	{
		if (conf_temp[i] != conf[i])
		{
			conf[i] = conf_temp[i];
		}
	}
#endif
}

void exit_conf_mode()
{
	clear_bit(WDTCSR,WDIE);
	conf_mode = 0;
	save_conf();
	display_main();
}

interrupt [WDT] void watchdog(void)
{
	exit_conf_mode();
}
